#include "chargementOFF.h"


using namespace std;
using namespace chargementOFF;

typedef OpenMesh::TriMesh_ArrayKernelT<> MyMesh;
namespace chargementOFF {

float translate[3];

pMaillage chargeMaillage(char *nomFich) {
    FILE *f;
    f = fopen(nomFich, "r");
    char c[3];
    float a[1];
    pMaillage maillage = (pMaillage) malloc(sizeof(tMaillage));
    int res;
    res = fread(c, sizeof(char), 3, f);
    res = fscanf(f, "%d", &maillage->nbsommets);
    res = fscanf(f, "%d", &maillage->nbindex);
    res = fscanf(f, "%f", a);
    maillage->sommets = (float*) malloc(sizeof(float) * 3 * maillage->nbsommets);

    for (int i = 0; i < 3*maillage->nbsommets; i++) {
        res = fscanf(f, "%f", maillage->sommets + i);
    }

    maillage->index = (int *) malloc( 3 * (maillage->nbindex) * sizeof(int));

    for (int i = 0; i < maillage->nbindex; i++) {
        res = fscanf(f, "%f", a);

        for (int j = 0; j < 3; j++) {
            res = fscanf(f, "%f", a);
            *(maillage->index + 3*i + j) = (int) * a;
        }
    }

    maillage->normales = (float*) malloc(sizeof(float) * 3 * maillage->nbindex);

    for (int i = 0; i < 3*maillage->nbindex; i++) {
        *(maillage->normales + i) = 0;
    }

    float u[3];
    float v[3];
    int ind0, ind1, ind2;
    float norm, x, y, z;

    for (int i = 0; i < maillage->nbindex; i++) {
        ind0 = *(maillage->index + 3 * i);
        ind1 = *(maillage->index + 3 * i + 1);
        ind2 = *(maillage->index + 3 * i + 2);

        for (int k = 0; k < 3; k++) {
            u[k] = *(maillage->sommets + 3 * ind0 + k) - *(maillage->sommets + 3 * ind2 + k);
            v[k] = *(maillage->sommets + 3 * ind1 + k) - *(maillage->sommets + 3 * ind2 + k);
        }

        /* produit vectoriel de u et v */
        x = u[1] * v[2] - u[2] * v[1];
        y = u[2] * v[0] - u[0] * v[2];
        z = u[0] * v[1] - u[1] * v[0];
        norm = sqrt(x * x + y * y + z * z);
        *(maillage->normales + 3*i) = x / norm;
        *(maillage->normales + 3*i + 1) = y / norm;
        *(maillage->normales + 3*i + 2) = z / norm;
    }

    fclose(f);
    return maillage;
}

pMaillage chargeMaillage(MyMesh* mesh) {
    MyMesh::VertexIter v_it;
    MyMesh::FaceIter f_it;
    MyMesh::Point p;
    int idx;
    int i, i_f;
    int vsize = mesh->n_vertices();
    pMaillage maillage = (pMaillage) malloc(sizeof(tMaillage));
    maillage->nbsommets = mesh->n_vertices();
    maillage->nbindex = mesh->n_faces();
    maillage->sommets = (float*) malloc(3 * maillage->nbsommets * sizeof(float));

    for (v_it = (*mesh).vertices_begin(); v_it != (*mesh).vertices_end(); ++v_it) {
        p = (*mesh).point(v_it);
        idx = ((MyMesh::VertexHandle) v_it).idx();

        for (i = 0; i < 3; ++i) {
            *(maillage->sommets + 3*idx + i) = p[i];
        }
    }

    maillage->index = (int *) malloc( 3 * (maillage->nbindex) * sizeof(int));
    MyMesh::HalfedgeHandle he_h, he_h_start;
    MyMesh::VertexHandle v_h;
    i_f = 0;

    for (f_it = (*mesh).faces_begin(); f_it != (*mesh).faces_end(); ++f_it) {
        he_h = (*mesh).halfedge_handle(f_it);

        for (i = 0; i < 3; ++i) {
            v_h = (*mesh).to_vertex_handle(he_h);
            idx = v_h.idx();
            *(maillage->index + 3*i_f + i) = idx;
            he_h = (*mesh).next_halfedge_handle(he_h);
        }

        ++i_f;
    }

    maillage->normales = (float*) malloc(sizeof(float) * 3 * maillage->nbindex);

    for (int i = 0; i < 3*maillage->nbindex; ++i) {
        *(maillage->normales + i) = 0;
    }

    float u[3];
    float v[3];
    int ind0, ind1, ind2;
    float norm, x, y, z;

    for (int i = 1; i < maillage->nbindex; ++i) {
        ind0 = *(maillage->index + 3 * i);
        ind1 = *(maillage->index + 3 * i + 1);
        ind2 = *(maillage->index + 3 * i + 2);

        for (int k = 0; k < 3; ++k) {
            u[k] = *(maillage->sommets + 3 * ind0 + k) - *(maillage->sommets + 3 * ind2 + k);
            v[k] = *(maillage->sommets + 3 * ind1 + k) - *(maillage->sommets + 3 * ind2 + k);
        }

        /* produit vectoriel de u et v */
        x = u[1] * v[2] - u[2] * v[1];
        y = u[2] * v[0] - u[0] * v[2];
        z = u[0] * v[1] - u[1] * v[0];
        norm = sqrt(x * x + y * y + z * z);
        *(maillage->normales + 3*i) = x / norm;
        *(maillage->normales + 3*i + 1) = y / norm;
        *(maillage->normales + 3*i + 2) = z / norm;
    }

    return maillage;
}

void traceMaillage(pMaillage maillage, float Colors[]) {
    glPushMatrix();
    GLfloat Normal[3];
    GLfloat Vertices[9];
    int ind;
    glEnableClientState(GL_VERTEX_ARRAY);
    glEnableClientState(GL_COLOR_ARRAY);
    glEnableClientState(GL_NORMAL_ARRAY);

    for (int i = 0; i < maillage->nbindex; i++) {
        for (int j = 0; j < 3; j++) {
            ind = *(maillage->index + 3 * i + j);
            Normal[j] = *(maillage->normales + 3 * i + j);

            for (int k = 0; k < 3; k++) {
                Vertices[3*j+k] = *(maillage->sommets + 3 * ind + k);
            }
        }

        glColorPointer(3, GL_FLOAT, 0, Colors);
        glVertexPointer(3, GL_FLOAT, 0, Vertices);
        glNormalPointer(GL_FLOAT, 0, Normal);
        glDrawArrays(GL_TRIANGLES, 0, 3);
    }

    glDisableClientState(GL_VERTEX_ARRAY);
    glDisableClientState(GL_COLOR_ARRAY);
    glDisableClientState(GL_NORMAL_ARRAY);
    glPopMatrix();
}


void traceCorrespondence(MyMesh *source, MyMesh *model, int nb_vertices, MyMesh::VertexHandle ** resultat) {
    glBegin(GL_LINES);
    float Blue[] = {0.0, 0.0, 1.0};
    MyMesh::VertexHandle v;
    MyMesh::Point p;

    for (int i = 0 ; i < nb_vertices  ; i++) {
        v = resultat[0][i];
        p = (*source).point(v);
        glColor3fv(Blue);
        glVertex3f(p[0], p[1], p[2]);
        v = resultat[1][i];
        p = (*model).point(v);
        glColor3fv(Blue);
        glVertex3f(p[0], p[1], p[2]);
    }

    glEnd();
}


void trace_V(MyMesh::Point p, MyMesh::Point s) {
    glBegin(GL_LINES);
    float Blue[] = {0.0, 0.0, 1.0};
    glColor3fv(Blue);
    glVertex3f(p[0], p[1], p[2]);
    glColor3fv(Blue);
    glVertex3f(s[0], s[1], s[2]);
    glEnd();
}


void traceKernelCorrespondence(MyMesh *source, MyMesh *model, list<assignment> kernel) {
    glLineWidth(3.0);
    glBegin(GL_LINES);
    float Blue[] = {0.0, 0.0, 1.0};
    MyMesh::VertexHandle v;
    MyMesh::Point p;

    for (list<assignment>::const_iterator it = kernel.begin(); it != kernel.end(); it++) {
        v = (*it).s;
        p = (*source).point(v);
        glColor3fv(Blue);
        glVertex3f(p[0], p[1], p[2]);
        v = (*it).t;
        p = (*model).point(v);
        glColor3fv(Blue);
        glVertex3f(p[0], p[1], p[2]);
    }

    glEnd();
    glLineWidth(1.0);
}

bool first = true;
int* couleurs;

void traceClusters(pMaillage maillage, list<Cluster*>* ls_clust) {
    glPolygonMode(GL_FRONT_AND_BACK, GL_FILL);
    glPushMatrix();
    const int nb_color = 12;
    float Color[nb_color+1][3] = {{0.0, 0.0, 0.0},
        {1.0, 0.0, 0.0}, {0.0, 1.0, 0.0}, {0.0, 0.0, 1.0},
        {1.0, 1.0, 0.0}, {0.0, 1.0, 1.0}, {1.0, 0.0, 1.0},
        {1.0, 0.5, 0.5}, {0.5, 1.0, 0.5}, {0.5, 0.5, 1.0},
        {1.0, 1.0, 0.5}, {0.5, 1.0, 1.0}, {1.0, 0.5, 1.0}
    };
    float color_cour[9];
    GLfloat Normal[3];
    GLfloat Vertices[9];
    int ind;

    if (first) {
        first = false;
        color_clusters(ls_clust, nb_color, &couleurs, maillage->nbsommets);
    }

    glEnableClientState(GL_VERTEX_ARRAY);
    glEnableClientState(GL_COLOR_ARRAY);
    glEnableClientState(GL_NORMAL_ARRAY);

    for (int i = 0; i < maillage->nbindex; ++i) {
        for (int j = 0; j < 3; ++j) {
            ind = *(maillage->index + 3 * i + j);
            Normal[j] = *(maillage->normales + 3 * i + j);

            for (int k = 0; k < 3; k++) {
                color_cour[3*j + k] = Color[couleurs[ind]][k];
                Vertices[3*j+k] = *(maillage->sommets + 3 * ind + k);
            }
        }

        glColorPointer(3, GL_FLOAT, 0, color_cour);
        glVertexPointer(3, GL_FLOAT, 0, Vertices);
        glNormalPointer(GL_FLOAT, 0, Normal);
        glDrawArrays(GL_TRIANGLES, 0, 3);
    }

    glDisableClientState(GL_VERTEX_ARRAY);
    glDisableClientState(GL_COLOR_ARRAY);
    glDisableClientState(GL_NORMAL_ARRAY);
    glPopMatrix();
    glPolygonMode(GL_FRONT_AND_BACK, GL_LINE);
}

}
