#include "cluster.h"

using namespace std;
using namespace icp2;
using namespace Clusters;

namespace Clusters {

void process_clustering(list<Cluster*>* ls_clust, MyMesh* source, MyMesh::VertexHandle** pts_src, MyMesh* cible, MyMesh::VertexHandle** pts_target, MyMesh::VertexHandle*** neighbors, MyMesh::VertexHandle*** correspondence, int nb_neighbors, double E_max) {
    // a decommenter pour avoir les traces
    //#define Verbose
    cout << "Computing the process clustering" << endl;
    Cluster* c;
    Cluster* c2 = new Cluster;;
    //boucle principale
    //cpt vaut les nombres de clusters initiaux
    int cpt = (*ls_clust).size();
    int arret = 0;
    //variables pour l'affichage de la fin
    list<Cluster*>::iterator iiit;
    list<Cluster*>::iterator iter;
    list<MyMesh::VertexHandle>::iterator iit;
    int tour = 1;
    //variables pour le programme
    list<Cluster*> voisins;
    list<Cluster*>::iterator k, l, t;
    list<MyMesh::VertexHandle>* c_etendu;
    list<MyMesh::VertexHandle>::iterator it, tt;
    list<MyMesh::VertexHandle> c_etendu_cible;
    list<MyMesh::VertexHandle>::iterator m;
    int fin = 0;
    //variables qui permettront de stocker les clusters à fusionner
    list<Cluster*> ls_fusion;
    Cluster* clust_fusionne;
    int num_cluster = (*ls_clust).size();
    double** transformation;
    double Err_cluster_tilde;
    MyMesh::VertexHandle* cc_etendu;
    MyMesh::VertexHandle* cc_etendu_cible;

    while (cpt != 0 && arret != (*ls_clust).size()) {
        // while (cpt!=0){
#ifdef Verbose
        cout << "# Clusterisation n° " << tour << " #" << endl;
        cout << "  " << endl;
        tour++;
#endif
        //on trie la liste des clusters selon l'erreur
        tri_err(ls_clust);
        //on traite le premier element de la liste des clusters non traité
        c = new Cluster;
        c = (*ls_clust).front();
        c2 = c;

        while ((*c).traiter == 1 && fin == 0) {
            (*ls_clust).pop_front();
            (*ls_clust).push_back(c);
            c = new Cluster;
            c = (*ls_clust).front();

            if (c == c2) {
                //on a fait le tour de la liste et il n'y a plus de clusters non traite
                cpt = 0;
                fin = 1;
            }
        }

//       fin=0;
//       iter=(*ls_clust).begin();
//       while (fin != 1){
// 	//for (iiit=(*ls_clust).begin();fin2 != 1 ;iiit++){
// 	if ((**iter).traiter == 0){
// 	  c=*iter;
// 	  fin=1;
// 	}
// 	iter++;
// 	if (iter == (*ls_clust).end()){
// 	    fin=1;
// 	    c=(*ls_clust).front();
// 	    cpt=0;
// 	}
//       }
        //on recupère la liste des clusters voisins de c
        voisins = (*c).clust_voisins;
        transformation = (double**)malloc(16 * sizeof(double));
        transformation = (*c).transfo;
#ifdef Verbose
        cout << "on traite le cluster : " << (*c).name << endl;
        cout << " " << endl;
        cout << "Ce cluster a " <<  ((*c).clust_voisins).size() << " voisin(s)" << endl;
        cout << " " << endl;

        for (t = voisins.begin(); t != voisins.end(); t++) {
            cout << "Cluster : " << (**t).name << endl;
        }

#endif

        for (k = (voisins).begin(); k != (voisins).end(); k++) {
            //*k represente un pointeur sur un Cluster. On effectue un parcours de ces voisins.
            //on calcule l'erreur Ekl correspondant (cf enonce)
            //on calcule le cluster etendu
            c_etendu = new list<MyMesh::VertexHandle>;
            cluster_tilde(*k, neighbors, c_etendu, nb_neighbors);
            //liste associée (pas optimisé....)
            it = (*c_etendu).begin();
            cc_etendu = new MyMesh::VertexHandle[(*c_etendu).size()];

            for (int u = 0; u < (*c_etendu).size(); u++) {
                cc_etendu[u] = *it;
                it++;
            }

            it = (*c_etendu).begin();
            cc_etendu_cible = new MyMesh::VertexHandle[(*c_etendu).size()];

            for (int u = 0; u < (*c_etendu).size(); u++) {
                cc_etendu_cible[u] = (*correspondence)[1][(*it).idx()];
                it++;
            }

            Err_cluster_tilde = mean_square_error(source, cc_etendu, cible, cc_etendu_cible, transformation, (*c_etendu).size());
#ifdef Verbose
            cout << "Erreur trouvé si on applique la transformation du cluster au cluster " << (**k).name << " voisin : " << Err_cluster_tilde << endl;
#endif

            //si l'erreur trouvée est inférieure au seuil fixé, on fusionne le cluster voisin avec le cluster traite
            if (Err_cluster_tilde < E_max) {
                ls_fusion.push_back((*k));
            }
        }

        //on ne fusionne que s'il y a des clusters à fusionner
        if (ls_fusion.size() != 0) {
            arret = 0;
            clust_fusionne = new Cluster;
            (*clust_fusionne).name = num_cluster;
            (*clust_fusionne).traiter = 0;
            num_cluster++;
            ls_fusion.push_back(c);
            fusion(&ls_fusion, clust_fusionne, neighbors, correspondence, source, cible, nb_neighbors);
#ifdef Verbose
            cout << "Le cluster fusion a pour numero : " << (*clust_fusionne).name << endl;
            cout << "Il provient de la fusion des clusters : ";

            for (l = ls_fusion.begin(); l != ls_fusion.end(); l++) {
                cout << (**l).name << " ; ";
            }

            cout << "" << endl;
#endif

            //on enleve tous les clusters qui ont ete fusionnes
            for (l = (ls_fusion).begin(); l != (ls_fusion).end(); l++) {
                (*ls_clust).remove(*l);
                cpt--;
            }

            //on rajoute la fusion de ceux ci
            (*ls_clust).push_back(clust_fusionne);
            cpt++;
        } else {
            arret++;
            (*ls_clust).pop_front();
            (*c).traiter = 1;
            (*ls_clust).push_front(c);
        }

        //on reinitialise la liste de fusion et le cluster etendu pour les prochains tours de boucle
        ls_fusion.clear();
        c_etendu_cible.clear();
    }

    cout << "Process clustering done" << endl;
}

void init_clusters(list<Cluster*>** ls_clust, MyMesh* source, MyMesh::VertexHandle** pts_source, MyMesh* cible, MyMesh::VertexHandle** pts_cible, MyMesh::VertexHandle*** correspondence, MyMesh::VertexHandle*** neighbors, int nb_vertices, int nb_neighbors) {
    list<MyMesh::VertexHandle> pt_src, pt_tgt;
    list<MyMesh::VertexHandle>::iterator it;
    list<MyMesh::VertexHandle>::iterator iit;
    list<Cluster*>::iterator k, iiit;
    MyMesh::VertexVertexIter vv_it;
    MyMesh::VertexHandle* pt_src2;
    MyMesh::VertexHandle* pt_tgt2;
    double** t;
    double e;
    int nb_clusters = 0;
    int i;
    Cluster *tab_clusters = new Cluster[nb_vertices];
    Sample s[nb_vertices];

    //on initialise la liste des clusters, avec chaque cluster qui correpond à un point de la source
    for (i = 0; i < nb_vertices; i++) {
        //on ajoute les proprietes du point dans le cluster c
        (tab_clusters[i]).name = i;
        //initialement, source et source prime sont egaux.
        s[i].source_subset = &((*pts_source)[i]);
        s[i].source_prim_subset = &((*pts_source)[i]);
        s[i].target = &((*correspondence)[1][((*pts_source)[i]).idx()]);
        (tab_clusters[i].V_set).push_back(s[i]);
        //on ne remplit pas la liste des clusters étendues auquels appartient le point pour le moment (sera fait dans la passe 2)
        //on remplit la liste de points source et cible
        (tab_clusters[i].pts_source).push_back((*pts_source)[i]);
        (tab_clusters[i].pts_cible).push_back((*correspondence)[1][(*pts_source)[i].idx()]);
        //on alloue de l'espace memoire pour trouver l'erreur et transformation associé
        t = (double**)malloc(16 * sizeof(double));
        pt_src.push_back((*pts_source)[i]);
        pt_tgt.push_back((*correspondence)[1][((*pts_source)[i]).idx()]);

        //le calcule des transformations se fait sur le cluster etendu : on rajoute les voisins du point traite
        for (int ii = 0; ii < nb_neighbors; ii++) {
            pt_src.push_back((*neighbors)[i][ii]);
            pt_tgt.push_back((*correspondence)[1][((*neighbors)[i][ii]).idx()]);
        }

        //liste associée (pas optimisé....)
        it = pt_src.begin();
        pt_src2 = (MyMesh::VertexHandle*)malloc(sizeof(MyMesh::VertexHandle) * (pt_src).size());

        for (int u = 0; u < pt_src.size(); u++) {
            pt_src2[u] = *it;
            it++;
        }

        pt_tgt2 = (MyMesh::VertexHandle*)malloc(sizeof(MyMesh::VertexHandle) * (pt_tgt).size());
        it = pt_tgt.begin();

        for (int u = 0; u < pt_tgt.size(); u++) {
            pt_tgt2[u] = *it;
            it++;
        }

        //on calcule l'erreur et la transformation associee
        Align(source, pt_src2, cible, pt_tgt2, &t, &e, pt_src.size());
        tab_clusters[i].transfo = t;
        tab_clusters[i].erreur = e;
        tab_clusters[i].traiter = 0;
        //on nettoie les variables associees
        pt_src.clear();
        pt_tgt.clear();
        (**ls_clust).push_back(&(tab_clusters[i]));
        nb_clusters = nb_clusters++;
    }

    //gestion des voisins : on recopie les clusters dans un tableau en les triant selon l'index du vhandle de leur seul point
    Cluster* tab_clusters_indexe[(**ls_clust).size()];

    for (k = (**ls_clust).begin(); k != (**ls_clust).end(); k++) {
        tab_clusters_indexe[(((*k)->pts_source).front()).idx()] = *k;
    }

    //on remplit les voisins des clusters EN CONSIDERANT QUE 2 CLUSTERS SONT VOISINS S'ILS ONT UNE ARETE EN COMMUN

    for (k = (**ls_clust).begin(); k != (**ls_clust).end(); k++) {
        //iteration sur les voisins du sommet du cluster initial
        for (vv_it = (*source).vv_iter(((*k)->pts_source).front()); vv_it; ++vv_it) {
            ((*k)->clust_voisins).push_back(tab_clusters_indexe[(vv_it.handle()).idx()]);
        }
    }
}

void tri_err(list<Cluster*>* ls_clust) {
    list<Cluster*> resu;
    list<Cluster*>::iterator k;
    list<Cluster*>::iterator l;
    int insertion;
    resu.push_back((*ls_clust).front());
    (*ls_clust).pop_front();

    for (l = (*ls_clust).begin(); l != (*ls_clust).end(); l++) {
        insertion = 0;
        k = resu.begin();

        //k est un iterateur; *k est un cluster*
        while (insertion == 0) {
            if (k != resu.end()) {
                if ((**l).erreur <= (**k).erreur) {
                    resu.insert(k, *l);
                    //s'il y a insertion, il faut sortir de la boucle while, d'ou l'entier insertion
                    insertion = 1;
                } else {
                    k++;
                }
            } else {
                resu.push_back(*l);
                insertion = 1;
            }
        }
    }

    (*ls_clust).push_back(resu.front());
    resu.pop_front();

    for (l = resu.begin(); l != resu.end(); l++) {
        (*ls_clust).pop_front();
        (*ls_clust).push_back(*l);
    }
}

void fusion(list<Cluster*>* ls_clust, Cluster* resultat, MyMesh::VertexHandle*** neighbors, MyMesh::VertexHandle*** correspondence, MyMesh* source, MyMesh* cible, int nb_neighbors) {
    double e;
    double** t;
    int u;
    list<MyMesh::VertexHandle> c_etendu;
    list<MyMesh::VertexHandle> c_etendu_cible;
    MyMesh::VertexHandle* cc_etendu;
    MyMesh::VertexHandle* cc_etendu_cible;
    list<MyMesh::VertexHandle>::iterator it;
    list<MyMesh::VertexHandle>::iterator m;
    list<Cluster*>::iterator k, ll;
    list<Cluster*>::iterator n;
    list<Sample>::iterator l;
    // a decommenter pour avoir les traces
    //#define Verbose
    //on part de l'hypothese qu'aucune point n'appartient à deux clusters d'ou on effectue toujours des reunions de listes, et pas des intersections
#ifdef Verbose
    cout << "Nombre de clusters à fusionner :" <<  (*ls_clust).size() << endl;
    cout << " " << endl;
#endif

    //on traite l'ensemble des clusters à fusionner
    for (k = (*ls_clust).begin(); k != (*ls_clust).end(); k++) {
        //fusion des points : on insere chaque point dans la liste (on parcours la liste et on les insère un par un)
        for (l = ((**k).V_set).begin(); l != ((**k).V_set).end(); l++) {
            ((*resultat).V_set).push_back(*l);
        }

        //gestion des voisins : les voisins du cluster resultat est la réunion des voisins de tous les clusters fusionnes, sauf les clusters qui sont dans la fusion
        for (n = ((**k).clust_voisins).begin(); n != ((**k).clust_voisins).end(); n++) {
            if (!appartient(*n, ls_clust)) {
                if (!appartient(&(**n), &((*resultat).clust_voisins))) {
                    ((*resultat).clust_voisins).push_back(*n);
                }

                //le cluster fusion est le nouveau voisin du voisin du cluster traité
                ((**n).clust_voisins).remove(*k);

                //on ne rajoute pas deux fois le cluster fusion en voisin
                if (!appartient(resultat, &((**n).clust_voisins))) {
                    ((**n).clust_voisins).push_back(resultat);
                }
            }
        }

        //fusion des points source
        for (m = ((**k).pts_source).begin(); m != ((**k).pts_source).end(); m++) {
            ((*resultat).pts_source).push_back(*m);
        }

        //fusion des points cibles
        for (m = ((**k).pts_cible).begin(); m != ((**k).pts_cible).end(); m++) {
            ((*resultat).pts_cible).push_back(*m);
        }

        //on calcule le cluster etendu
        cluster_tilde(resultat, neighbors, &c_etendu, nb_neighbors);
        cc_etendu = new MyMesh::VertexHandle[c_etendu.size()];
        u = 0;

        for (it = c_etendu.begin(); it != c_etendu.end(); it++) {
            cc_etendu[u] = *it;
            u++;
        }

        u = 0;
        cc_etendu_cible = new MyMesh::VertexHandle[c_etendu.size()];

        for (it = c_etendu.begin(); it != c_etendu.end(); it++) {
            cc_etendu_cible[u] = (*correspondence)[1][(*it).idx()];
            u++;
        }

        //on modifie la transformation et l'erreur
        t = (double**)malloc(16 * sizeof(double));
        Align(source, cc_etendu, cible, cc_etendu_cible, &t, &e, c_etendu.size());
        (*resultat).transfo = t;
        (*resultat).erreur = e;
    }
}

bool appartient(Cluster* c, list<Cluster*>* ls_clust) {
    list<Cluster*>::iterator k;

    for (k = (*ls_clust).begin(); k != (*ls_clust).end(); k++) {
        if (c == *k) {
            return true;
        }
    }

    return false;
}

void cluster_tilde(Cluster* c, MyMesh::VertexHandle*** neighbours, list<MyMesh::VertexHandle>* resultat, int nb_neighbors) {
    //list<MyMesh::VertexHandle> resu=(*c).pts_source;
    list<MyMesh::VertexHandle>::iterator k;
    MyMesh::VertexHandle l;

    for (k = ((*c).pts_source).begin(); k != ((*c).pts_source).end(); k++) {
        (*resultat).push_back(*k);

        for (int i = 0; i < nb_neighbors; i++) {
            l = ((*neighbours)[(*k).idx()][i]);
            //on s'assure que la liste ne contient pas plusieurs fois le Handle : on supprime l'élèmenet si il existe et on l'ajoute... on peut optimiser le truc..
            (*resultat).remove(l);
            (*resultat).push_back(l);
        }
    }
}

void color_clusters(list<Cluster*>* ls_clust, const int nb_color, int** couleurs, const int vsize) {
    //cout << "Enter color_cluster" << endl;
    const int nb_c = nb_color + 1; // nombre de couleur + 1
    list<Cluster*>::iterator c_it;
    Cluster* cl;
    int i, j, c_cour;
    int size = (*ls_clust).size();
    list<Cluster*> stack;
    bool* non_traite = new bool[size];
    // initialisation : name, ind_color
    i = 0;

    for (c_it = (*ls_clust).begin(); c_it != (*ls_clust).end(); ++c_it) {
        (*c_it)->name = i;
        (*c_it)->ind_color = new int[nb_c];

        for (j = 0; j < nb_c; ++j) {
            (*c_it)->ind_color[j] = 0;
        }

        ++i;
    }

    // initialisation : non_traite, stack
    for (i = 0; i < size; ++i) {
        non_traite[i] = true;
    }

    stack.push_back((*ls_clust).front());
    non_traite[((*ls_clust).front())->name] = false;
    c_cour = 1;

    while (stack.size() != 0) {
        cl = stack.front();
        stack.pop_front();

        // i <- premiere couleur disponible
        for (i = c_cour; cl->ind_color[0] == 0; ++i) {
            if (i >= nb_c) i = 1;

            if (cl->ind_color[i] == 0 || i == nb_c - 1) {
                cl->ind_color[0] = i;
            }
        }

        c_cour = i;
        --i;

        // printf("cluster %d -> ind_color :",cl->name);
        for (j = 0; j < nb_c; ++j) {
            // printf(" %d",cl->ind_color[j]);
        }

        // printf("");

        // rend i indisponible pour les voisins
        // printf("\tvoisins :");
        for (c_it = cl->clust_voisins.begin(); c_it != cl->clust_voisins.end(); ++c_it) {
            (*c_it)->ind_color[i] = 1;

            // printf(" %d",(*c_it)->name);
            if (non_traite[(*c_it)->name]) {
                // printf("*");
                non_traite[(*c_it)->name] = false;
                stack.push_back(*c_it);
            }
        }
    }

    // couleurs <- resultat
    *couleurs = new int[vsize];
    list<Cluster*>::iterator cc_it;
    list<Sample>::iterator s_it;

    for (c_it = (*ls_clust).begin(); c_it != (*ls_clust).end(); ++c_it) {
        cl = *c_it;

        for (s_it = cl->V_set.begin(); s_it != cl->V_set.end(); ++s_it) {
            (*couleurs)[(*s_it).source_subset->idx()] = cl->ind_color[0];
        }
    }

    //cout << "Leave color_cluster" << endl;
}

}
