#ifndef INTERFACE_H
#define INTERFACE_H

#include "chargementOFF.h"
#include <QGLViewer/qglviewer.h>
#include <GL/glut.h>

struct _Command_line;

typedef _Command_line Command_line;

struct _Command_line {
    int mod_consistency;
    double consistency;
    int mod_emax;
    double Emax;
    int display_source;
    int display_model;
    int display_correspondence;
    int display_deformation;
    int display_clusters;
    int normals;
    int nb_iteration;
    int fill_mesh;
    int N;

};

class Viewer : public QGLViewer {
public:
    void loadModel(char* a, Command_line command);
    void loadModel(int argc, char** argv, Command_line command, int nb_off);
protected :
    virtual void draw();
    virtual void init();
    virtual QString helpString() const;
};
#endif
